Imports System
Imports System.Data
Imports MySql.Data.MySqlClient
Imports MySql.Data.Types


Module Module1

  Sub Main()
    Dim myConnection As New MySqlConnection("DataSource=127.0.0.1;database=test_transaction;uid=root;pwd=;pooling=false;")
    myConnection.Open()

    Dim myCommand As MySqlCommand = myConnection.CreateCommand()
    Dim myTrans As MySqlTransaction

    ' Start a local transaction
    myTrans = myConnection.BeginTransaction()
    ' Must assign both transaction object and connection
    ' to Command object for a pending local transaction
    myCommand.Connection = myConnection
    myCommand.Transaction = myTrans

    Try
      myCommand.CommandText = "uspAddTable1Record"
      myCommand.CommandType = CommandType.StoredProcedure

      myCommand.Parameters.Add("?p_strTable1Description", "Test from VB.NET -Record 1")
      myCommand.Parameters("?p_strTable1Description").Direction = ParameterDirection.Input

      Dim drCommandResults As MySqlDataReader = myCommand.ExecuteReader()
      Dim intTable1ID As Integer

      ' Should be 1 and only 1 record returned
      If drCommandResults.Read = True Then
        ' Get the new ID
        intTable1ID = Convert.ToInt32(drCommandResults.Item(0))
      End If

      drCommandResults.Close()

      myCommand.CommandText = "uspAddTable1Record"
      myCommand.CommandType = CommandType.StoredProcedure

      myCommand.Parameters.Add("?p_strTable1Description", "Test from VB.NET -Record 2")
      myCommand.Parameters("?p_strTable1Description").Direction = ParameterDirection.Input

      Dim drCommandResults2 As MySqlDataReader = myCommand.ExecuteReader()
      Dim intTable2ID As Integer

      ' Should be 1 and only 1 record returned
      If drCommandResults2.Read = True Then
        ' Get the new ID
        intTable2ID = Convert.ToInt32(drCommandResults2.Item(0))
      End If

      drCommandResults2.Close()

      myTrans.Commit()
      Console.WriteLine("Both records are written to database.")
    Catch e As Exception
      Try
        myTrans.Rollback()
      Catch ex As MySqlException
        If Not myTrans.Connection Is Nothing Then
          Console.WriteLine(ex.ToString)
        End If
      End Try

      Console.WriteLine(e.ToString)
      Console.WriteLine("Neither record was written to database.")
    Finally
      myConnection.Close()
    End Try
  End Sub

End Module
